<script>
  import {scaleLinear} from 'd3-scale';
  import {scaleBand} from "d3-scale";
  import {extent} from "d3-array";
  import {axisBottom, axisLeft} from "d3-axis";
  import {select} from "d3-selection";

  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  let services = [];
  for(const d of data){
    services.push(d.service);
  }

  let scaler_y = scaleLinear().domain([0, 3]).range([innerHeight, margin.bottom]);
  let scaler_x = scaleBand().domain(services).range([0, innerWidth]);

  let left_axis = axisLeft(scaler_y);
  let bottom_axis = axisBottom(scaler_x);

  function addLeftAxis(){
    select("#left_axis").call(left_axis);
  }
  function addBottomAxis(){
    select("#bottom_axis").call(bottom_axis);
  }
</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <text x="-50" y=130 transform="rotate(-90 0 115)">viewers</text>
  <g id="left_axis" use:addLeftAxis transform={`translate(${margin.left-20},${margin.top})`}>
  </g>
  <g transform={`translate(${margin.left},${margin.top})`}>
    <!--  -->
    {#each data as d}
      <rect x={scaler_x(d.service)} y={scaler_y(d.viewers)} height={innerHeight - scaler_y(d.viewers)} width=50 fill="skyblue"/>
    {/each}
  </g>
  <g id="bottom_axis" use:addBottomAxis transform={`translate(${40}, ${height-margin.bottom})`}></g>
  <!-- <g use:addLeftAxis id="left-axis"></g> -->
</svg>
